// ==================================================================
// OpenGL Rendering of the IFS data
// ==================================================================

#include "OpenGLCanvas.h"
#include "argparser.h"
#include "ifs.h"

class OpenGLRenderer {

public:

  OpenGLRenderer(IFS *_ifs, ArgParser *args);

  // HELPER FUNCTIONS FOR RENDERING
  void setupVBOs();
  void drawVBOs(GLuint MatrixID,const glm::mat4 &MVP);
  void cleanupVBOs();
  
private:

  // private helper functions for VBOs
  void setupPoints();
  void drawPoints() const;
  void cleanupPoints();
  void setupCube();
  void drawCube() const;
  void cleanupCube();

  // REPRESENTATION
  IFS *ifs;
  
  GLuint VaoId;
  GLuint VboId;
};


class VertexPosColor {
public:
  // by default vertices are set to black
  VertexPosColor(const glm::vec4 &pos=glm::vec4(0,0,0,1), 
                 const glm::vec4 &color=glm::vec4(0,0,0,1)) :
    XYZW(pos),RGBA(color) {}
    glm::vec4 XYZW;
    glm::vec4 RGBA;
};
