// ================================================================
// Parse the command line arguments and the input file
// ================================================================

#ifndef __ARG_PARSER_H__
#define __ARG_PARSER_H__

#include <string>

class IFS;

// ====================================================================
// ====================================================================

class ArgParser {

public:
  
  ArgParser(int argc, const char *argv[], IFS *_ifs);

  // helper functions
  void separatePathAndFile(const std::string &input, std::string &path, std::string &file);
  void parseInputFile();
  
  // ==============
  // REPRESENTATION
  // all public! (no accessors)

  std::string input_file;
  std::string path;
  IFS *ifs;
};

#endif
