#ifndef _IFS_H_
#define _IFS_H_

#define NUM_CUBE_TRIANGLES 12 
#define NUM_CUBE_VERTS NUM_CUBE_TRIANGLES * 3

// ====================================================================
// ====================================================================
// This file contains the simple shared data structures for the
// "iterated function system" IFS that are compatible with C++ and
// OpenGL and Objective-C and Metal.


// a homogenous 3D point or a color with alpha
typedef struct float4 {
  float data[4];
} float4;

// a vertex with position and color
typedef struct float8 {
  float data[8];
} float8;

// a 4x4 matrix
typedef struct float16 {
  float data[16];
} float16;

// position and color data for the unit cube
extern const float8 cube[12*3];

typedef struct IFS {
  
  // REPRESENTATION
  int point_count;
  int cube_count;

  int iters;
  int width;
  int height;

  bool cubes;
  bool perspective;
  
  float* pointData;
  float* cubeData;
  

  // ASSIGNMENT: add whatever additional variables you need

  
} IFS;


void INIT_IFS(IFS *ifs);
void generatePoints(IFS *ifs);
void generateCubes(IFS *ifs);


// ASSIGNMENT: add whatever additional functions you need


// ====================================================================
// ====================================================================

#endif
