#include "argparser.h"
#include "ifs.h"


// =========================================================
// OS specific rendering for OpenGL and Apple Metal
// =========================================================
#if __APPLE__
extern "C" {
int NSApplicationMain(int argc, const char * argv[]);
}
#else
#include "OpenGLRenderer.h"
#endif


// The one significant global variable
IFS *ifs;



int main(int argc, const char * argv[]) {

  
  // parse the command line arguments and initialize the IFS
  IFS myifs;
  ifs = &myifs;
  INIT_IFS(ifs);
  ArgParser args(argc, argv, ifs);

  
  // generate the position and color information for rendering
  generatePoints(ifs);
  generateCubes(ifs);


  // launch the OS specific renderer
#if __APPLE__
  return NSApplicationMain(argc, argv);
#else
  OpenGLRenderer opengl_renderer(ifs,&args);
#endif
}
